<?php
/*
 +-------------------------------------------------------------------------+
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************
    Author ......... Jean-Michel Pepin classes plugin for network devices (PEPJ in forum.cacti.net & http://cactiusers.org/forums/)
    Modified ....... .
    Program ........ class definition for network 3Com devices in PHP for Cacti or PHP software

    congratulation: Thanks to all the developpers of cacti http://www.cacti.net, 
     
*******************************************************************************/
/* define the OID of the vendor */
$toidvendor['a3com']         = '.1.3.6.1.4.1.43';
$toidtovendor['.1.3.6.1.4.1.43'] = 'a3com';

class a3comnetworkclass
{
   function vendorname($FunctionName)
   {
        return "3com";       
   }
   function showclass()
   {
        return "this is a 3com class";       
   }
   function priv($obj,$FunctionName,$param="")
   {
   	$fct = "a3com".$FunctionName;
   	if (function_exists($fct)) $ret = ($param=="") ? $fct($obj) : $fct($obj,$param);
       	else {
       	  $ret=0;
          $obj->result= array();
          $obj->errormsg = "Error: Function does not exist.";
          $obj->retcode = $ret;
       	}
        return $ret;
   }

   function tftp($obj)
   {
     global $networkclass_isdebug,$networkclass_islog;
      // to check if several types
      $typtransfert = a3comChecktypdevice($obj->description);
      switch ($typtransfert) {
	case "a3Com":
	  if ($obj->inittftp) {
	  	a3comTFTPtransfert($obj);
	  }
	  break;
	default:
	   $obj->result= "unknow device";
	   $obj->retcode = 0;
	  break;
      }
   }
   /* return if the device is a host */
   function DeviceIsHost($objdevice,$init=false) {
     global $networkclass_isdebug,$networkclass_islog;
     // 3Com always false

     // the two following value could help you to find it
     // $obj->description();  // to be sure description has been ask at least one time
     // $description = $obj->result; or $description = $obj->description;
     // $oiddevice = $objdevice->oiddevice;
     //force debug $objdevice->setdebug(true,true);
     // if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG DeviceIsHost ->".print_r($valmib,true)."\n");
     if ($init) {
        $objdevice->ishost =false;
     }
     $result= $objdevice->ishost;
     return $result;
   }
}

function a3comTrunk($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $mib="a3ComTrunkIfStatus";
 $a_xmlmib = array(array("source"=>"GENERIC-3COM-TRUNK-MIB.xml"));
 $ret=0;
 $msg = "";
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG a3comTrunk Load MIB ->".print_r($a_xmlmib,true)."\n");
 searchin_xmlMIB($a_xmlmib,$mib,$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG a3comTrunk MIB search of $mib ->".print_r($valmib,true).", result=>".$objdevice->result."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   /*!!!! 1 : trunking 2 : notTrunking  in order to have always the same answer */
    $result= $objdevice->result;
    $ret=$objdevice->retcode;
    $msg = $objdevice->errormsg;
 } else {
    $result= array();
    $msg = "no response";
 }
 $objdevice->result= $result;
 if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG a3comTrunk result ->".print_r($result,true)."\n");
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $ret;
 return $ret;
}

/* ************************************************************************
 VLAN : should return an array like in order to be independant for vendors
 $result["state"][vlanindex] = "0" for no VLAN or VLAN number;
 $result["VlanID"][vlanindex] = "0" for no VLAN or VLAN number;
 $result["index"][vlanindex] = ifindex;
 $result["nbport_by_vlan"][vlanindex] = nb ports in vlan
 $result["port_by_vlan"][vlanindex][] = array of ports in vlan
 $result["vlan_by_port"][vlanindex][] = array of ports in vlan
 $result["otherinfos"][] = array of other infos
 */
function a3comVLAN($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $vlanstate= array(); 
 $vlanname = array(); 
 $vlanindex = array();
 $arrayofnbportsinvlan = array();
 $arrayofportsinvlan = array();
 $snmpok=0;
 $msg = "Error: MIB not exist.";
 $a_xmlmib = array(array("source"=>"a3com-generic-vlan-mib.xml"));
 /* search the VLAN information */
 searchin_xmlMIB($a_xmlmib,"VlanIfStatus",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("Function in developpement ... \n DEBUG 3COM VLAN state MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok1=$objdevice->retcode;
   /* give active(1)notInService(2) notReady(3).*/
   /* we want "0" no vlan active "1","2",... for other state" */
   if ($snmpok1) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanstate);
        foreach ($vlanstate as $index => $value) if ($vlanstate[$index]!="1") $vlanstate[$index]="0";
        $msg= "";
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG 3COM VLAN state array ->".print_r($vlanstate,true)."\n");
 }
 searchin_xmlMIB($a_xmlmib,"a3ComVlanIfDescr",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG 3COM VLAN name MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok2=$objdevice->retcode;
   if ($snmpok2) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanname);
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG 3COM VLAN vlanname ->".print_r($vlanname,true)."\n");
 }
 searchin_xmlMIB($a_xmlmib,"a3ComVlanIfIndex",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG 3COM VLAN VLanId MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok3=$objdevice->retcode;
   if ($snmpok3) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanindex);
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG 3COM VLAN VLanId ->".print_r($vlanindex,true)."\n");
 }

 searchin_xmlMIB($a_xmlmib,"a3ComVlanGlobalMappingIfIndex",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG 3COM Port a3ComVlanGlobalMappingIfIndex MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok3=$objdevice->retcode;
   if ($snmpok3) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$arrayofvlanlist);
   	foreach ($vlanindex as $i => $vlan) {
   	 $nbr=0;
   	 $arrayofportsinvlan[$vlan]=array(); 
   	 foreach ($arrayofvlanlist as $ifndx => $ifvlan) {
   	  if ($ifvlan==$vlan) {
   	  	$nbr=$nbr+1;
   	  	$arrayofportsinvlan[$vlan][$nbr]= $ifndx;
   	  }
   	 }
   	 $arrayofnbportsinvlan[$vlan]=$nbr;
   	}
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG 3COM VLAN Port a3ComVlanGlobalMappingIfIndex ->".print_r($vlanindex,true)."\n");
 }
 /* convert to ifindex !!!!!*/
 $result["index"] = @$vlanindex;
 $result["state"] = @$vlanstate;
 $result["VlanID"] = @$vlanname;
 $result["nbport_by_vlan"] = @$arrayofnbportsinvlan;
 $result["port_by_vlan"] = @$arrayofportsinvlan;
 $result["vlan_by_port"] = array();
 foreach ($arrayofportsinvlan as $vlanID => $tport) {
    foreach ($tport as $ndx => $port) {
     $result["vlan_by_port"][$port][] = $vlanID;
    }
 }
 $objdevice->result= $result;
// if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG 3COM VLAN result ->".print_r($result,true)."\n");
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok1;
 return $snmpok1;
}



/* ************************************************************************
 Channel : should return an array with all type of channel like ... in order
  to be independant for vendors who have severals channel types
 $result["channelindex"][0..x]=channeltype (at least "LACP")
 $result["LACP"]["AdminKey"][ifIndex] = AdminKey of LaCP channel;  // "dot3adAggPortActorAdminKey"
 $result["LACP"]["OperKey"][ifIndex] = OperKey of LaCP channel;    // "dot3adAggPortActorOperKey"
 $result["LACP"]["PortActorAdminState"][ifIndex] = Port Selected in which index of the LaCP channel // "dot3adAggPortActorAdminState"
 $result["LACP"]["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel // "dot3adAggPortActorOperState"
 
 $result["other type of channel"]["PortActorOperState"][ifIndex] = ...;     "..."
 $result["other type of channel"]["pagpGroupIfIndex"][ifIndex] = Port Attached in which index of the ... channel or 0 for not attached
 ....
 */
function a3comChannel($objdevice) {
 networkclass_LACP($objdevice);
 $snmpok1 = $objdevice->retcode;
 $lacp = $objdevice->result;
 $result["channelindex"][0] = "LACP";
 $result["LACP"] = $lacp;
 $snmpok = $snmpok1;
 $objdevice->result =$result;
 if ($snmpok) $objdevice->errormsg = "";
 return $snmpok;
}

/* ************************************************************************
 LACP : should return an array like in order to be independant for vendors
 per default IEEE8023-LAG-MIB
 $result["AdminKey"][ifIndex] = AdminKey of LaCP channel;   "dot3adAggPortActorAdminKey"
 $result["OperKey"][ifIndex] = OperKey of LaCP channel;     "dot3adAggPortActorOperKey"
 $result["PortActorAdminState"][ifIndex] = Port Selected in which index of the LaCP channel
 $result["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel
 */
function a3comLACP($objdevice) {
 networkclass_LACP($objdevice);
 return $objdevice->retcode;
}

/* CPU : should return an array like
 $result["firstaveragename"][0] = value 1. average;
 $result["2averagename"][0] = value 2. average;
 $result["3averagename"][0] = value 3. average;
*/
function a3comCPU($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $a_xmlmib = array(); //array(array("source"=>"mibfileforcpu.xml"));
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG a3comCPU Load MIB ->".print_r($a_xmlmib,true)."\n");
 $snmpok=0;
 $result["5sec"] = 0;
 $result["1min"] = 0;
 $result["5min"] = 0;
 $msg = "Error: CPU no response";
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG a3comCPU result ->".$msg."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Temperature : should return an array of temperature (in degres Celsius) like
 $result["modulename"][0] = modulename; or ""
 $result["mean"][0] = 0;
 $result["min"][0] = value; or ""
 $result["max"][0] = value; or ""
 $result["state"][0] = value; or ""
PS: Fahrenheit to celsius (F - 32) / 1.8
*/
function a3comTemperature($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $a_xmlmib = array(); //array(array("source"=>"mibfilefortemerature.xml"));
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG a3com temperature Load MIB ->".print_r($a_xmlmib,true)."\n");
 $result=array();
 $snmpok=0;
 $msg = "a3com Temperature Status Table not enabled or not supported.";
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG a3com temperature result ->".$msg."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Fan : should return an array of Fan state () like
 $result["description"][index] = decription where index is the index number of the fan
 $result["state"][index] = "ok" or "down" "not present" are mandatory for functioning / not functioning , or an another text
*/
function a3comFan($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $a_xmlmib = array(array("source"=>"a3com-switching-systems-mib.xml"));
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG 3com Fan Load MIB ->".print_r($a_xmlmib,true)."\n");
 $snmpok=0;
 $msg = "3com snChasFanDescription not enabled or not supported.";
 $tdescription= array();
 $ok1=true;
 $tstate = array();
 if ($ok1) {
   $mib="a3ComSysSystemFanFailure";
   searchin_xmlMIB($a_xmlmib,$mib,$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG 3com Fan state MIB search of $mib ->".print_r($valmib,true)."\n");
   networkclass_give_snmp($objdevice,$valmib);
   $ok2=$objdevice->retcode;
   if ($ok2) {
     $val = $objdevice->result;
     $tdescription[0] = "Fan";
      switch ($val) {
      	case 1:
      	  $tstate[0] = "ok";
      	  break;
      	case 2:
      	  $tstate[0] = "critical";
      	  break;
      	default:
      	  $tstate[0] = "not enabled";
      }
   }
 }
 $snmpok = $ok1 && $ok2;
 $result["description"] = $tdescription;
 $result["state"] = $tstate;
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG 3com Fan result ->".print_r($result,true)."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 RAM : should return an array of RAM 
 $result["RAM"] = 
 $result["RAMused"] = 
*/
function a3comRAM($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
  $result = array();
  $ret=0;
  $msg = "Error: RAM status table not enabled or not supported.";
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG a3com RAM not enabled or not supported"."\n");
  $objdevice->result= $result;
  $objdevice->errormsg = $msg;
  $objdevice->retcode = $ret;
  return $ret;
}

/* ************************************************************************
 MAC : for the VlanID should return an array of MAC addresses like
 $result[interfaceindex][indexMAC] -> Macaddress where interfaceindex is the inteface index
*/
function a3comMAC($objdevice,$vlanID) {
 networkclass_MAC($objdevice,$vlanID);
 return $objdevice->retcode;
}

/* ************************************************************************
 STPchanges : for the VlanID should return an array of 
 $result["TopChanges"] -> The total number of topology changes detected by this bridge since the management entity was last reset or initialized.
 $result["TimeSinceTopologyChange"] -> The time (in hundredths of a second) since the last time a topology change was detected by the bridge entity.
*/
function a3comSTPchanges($objdevice,$vlanID="") {
 networkclass_STPchanges($objdevice,$vlanID);
 return $objdevice->retcode;
}


function a3comChecktypdevice($description="") {
   $typtransfert = "a3Com";
/*
   $typtransfert = "unknow";
   $pattern= '/(?:TOTEST)|(?:TOTEST2-)/i'; 
   switch (true) {
	case preg_match($pattern,$description)>0:
	  $typtransfert = "a3Com";
	  break;
	default:
	  break;
   }
*/
   return $typtransfert;
}

/*
1.3.6.1.4.1.43.10.27.1 A3COM0017-STACK-CONFIG 
1.3.6.1.4.1.43.10.43 	A3COM0469-BACKUP-AND-RESTORE 
a3ComBackup-mib	GROUP	1.3.6.1.4.1.43.10.43
iso(1). org(3). dod(6). internet(1). private(4). enterprises(1). a3Com(43). generic(10). a3ComBackup-mib(43)
  	a3ComBackupNecessary	SCALAR	read-only	TruthValue	1.3.6.1.4.1.43.10.43.1.0
  	a3ComBackupTftpServer	SCALAR	read-write	IpAddress	1.3.6.1.4.1.43.10.43.2.0
  	a3ComBackupFilename	SCALAR	read-write	DisplayString	1.3.6.1.4.1.43.10.43.3.0
  	a3ComBackupAgentComment	SCALAR	read-only	DisplayString	1.3.6.1.4.1.43.10.43.4.0
  	a3ComBackupUserComment	SCALAR	read-write	DisplayString	1.3.6.1.4.1.43.10.43.5.0
  	a3ComBackupAction	SCALAR	read-write	INTEGER	1.3.6.1.4.1.43.10.43.6.0
  	a3ComBackupStatus	SCALAR	read-only	BackupStatus	1.3.6.1.4.1.43.10.43.7.0
  	a3ComBackupBytes	SCALAR	read-only	INTEGER	1.3.6.1.4.1.43.10.43.8.0
  	a3ComBackupFailedCommand	SCALAR	read-only	DisplayString	1.3.6.1.4.1.43.10.43.9.0
  	a3ComBackupFailureReason	SCALAR	read-only	DisplayString	1.3.6.1.4.1.43.10.43.10.0
  	a3ComBackupResetNecessary	SCALAR	read-only	TruthValue	1.3.6.1.4.1.43.10.43.11.0
  	a3ComBackupLastAction	SCALAR	read-only	INTEGER	1.3.6.1.4.1.43.10.43.12.0
*/

function a3comTFTPtransfert($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok=0;
 $error ="";
 $ret_val="";
 $result ="";
  $oid = array(
		"tftphost" => ".1.3.6.1.4.1.43.10.43.2.0" 
		,"file" => ".1.3.6.1.4.1.43.10.43.3.0"
		,"action"	  => ".1.3.6.1.4.1.43.10.43.6.0"
		,"result"    => ".1.3.6.1.4.1.43.10.43.7.0" 
             );

  $action = array("notActive"   => '1',	 
 		"abortAction"   => '2',	 
 		"cliSave"   => '3',	 //"downloadConfig"
 		"cliVerify"   => '4',	 
 		"binarySave"   => '5',	 //"downloadConfig"
 		"binaryVerify"   => '6',	 
 		"restoreConfig"   => '7',	//"uploadconfig" 
 		"restoreIgnoringErrors"   => '8',	//"uploadconfig" 
 		"loadDescriptionOnly"   => '9',	 
 		"takeSnapshot"   => '10'	
                 );
	
  $state = array(
 		"backupTftpFileNotFound"     => "1",	
 		"backupTftpAccessViolation"     => "2",	
 		"backupTftpDiskFull"     => "3",	
 		"backupTftpIllegalOperation"     => "4",	 
 		"backupTftpUnknownTransferId"     => "5",	
 		"backupTftpFileExists"     => "6",	
 		"backupTftpNoSuchUser"     => "7",	
 		"backupNoResponse"     => "8",	
 		"backupNoResource"     => "9",	
 		"backupRecordLengthMismatch"     => "10",	 
 		"backupBadRecordType"     => "11",	 
 		"backupChecksumError"     => "12",	
 		"backupWrongHardwareType"     => "13",	 
 		"backupWrongHardwareVersion"     => "14",	
 		"backupHeaderMissing"     => "15",	
 		"backupByteCountIncorrect"     => "16",	 
 		"backupAddressIncorrect"     => "17",	
 		"backupErasureFailed"     => "18",	 
 		"backupFlashProgramFailed"     => "19",	
 		"backupWaitingToStart"     => "20",	
 		"backupOperationInProgress"     => "21",	
 		"backupOperationSucceeded"     => "22",	
 		"backupAbortedByUser"     => "23",	
 		"backupNotRequired"     => "24",	
 		"backupUnknownFailure"     => "25",	
 		"backupAbortedAutomatically"     => "26",	
 		"backupFileValid"     => "27",	
 		"backupBadCommand"     => "28",	
 		"backupCommandFailed"     => "29",	
 		"backupFilenameInvalid"     => "30",	
 		"backupTftpServerInvalid"     => "31"	
		);

  $filetftp  = ($objdevice->tftpparam["source"]=='tftp')
             ? $objdevice->tftpparam["filesrc"]
             : $objdevice->tftpparam["filedest"];
  if ($objdevice->tftpparam["binary"]==1) {
     $theaction = ($objdevice->tftpparam["source"]=='tftp')
             ? $action["binarySave"] : $action["restoreConfig"];
  } else {
     $theaction = ($objdevice->tftpparam["source"]=='tftp')
             ? $action["cliSave"] : $action["restoreConfig"];
  }
  if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG transfert: "."file=$filetftp"."\n");
  // set up the request
  $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oid["tftphost"], "type" => 'a', "value" => "".$objdevice->tftpparam["tftpip"])
 		// set the filename being written
 		,array("oid" => $oid["file"], "type" => 's', "value" => $filetftp)
 		// 
 		,array("oid" => $oid["action"], "type" => 'i', "value" => $theaction)
		);
  $snmpok = $objdevice->set_list($to_do);
  $snmpok= $objdevice->retcode;

  if ($snmpok) {
    //set default status as "running"
    $result = $state["backupWaitingToStart"];
    $snmpok= true;
    $j = 0;
    // check for the results status
    while ($snmpok && ( (($result == $state["backupOperationInProgress"]) || ($result == $state["backupWaitingToStart"])) && ($j <20)) ) {
		  // get the current status of the tftp server's action
		  $objdevice->get($oid["result"]);
		  $snmpok= $objdevice->retcode;
		  $ret_val = $objdevice->result;
		  $result = $ret_val;
                   sleep(3);
		  $j++; // not wait more than 60 seconds 
    }
    if ($result!=$state["backupOperationSucceeded"]) {
       $ret_val= $error = "Error: SNMP Session failed during Transfert. ";
       foreach ($state as $ndx => $val) {
       	  if ($val == $result) {
       	    $ret_val.= $ndx;
       	    $error  .= $ndx;
       	  }
       }
       $snmpok = 0;
    }
  } else {
    $ret_val= $error = "Error: SNMP Session failed during setting commands. ";
    $snmpok = 0;
  }

   $objdevice->result  = $ret_val;
   $objdevice->errormsg = $error;
   $objdevice->retcode = $snmpok;
}

function a3comTFTPtransfertOLD($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok=0;
 $error ="";
 $ret_val="";
 $result ="";
  $oid = array(
		"tftphost" => ".1.3.6.1.4.1.43.47.1.24.1.6.0" 
		,"file" => ".1.3.6.1.4.1.43.47.1.24.1.4.0"
		,"action"	  => ".1.3.6.1.4.1.43.47.1.24.1.8.0"
		,"result"    => "" 
             );

  $action = array( "uploadconfig"   => '1'
                   ,"downloadConfig"=> '2'
                 );

  $state = array(
		"none"	           => "1",  
		"inProgress"	   => "2",  
		"success"            => "3",  
		"fail"     => "4"
		);

  $filetftp  = ($objdevice->tftpparam["source"]=='tftp')
             ? $objdevice->tftpparam["filesrc"]
             : $objdevice->tftpparam["filedest"];
  $theaction = ($objdevice->tftpparam["source"]=='tftp')
             ? $action["downloadConfig"] : $action["uploadconfig"];

  if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG transfert: "."file=$filetftp"."\n");
  // set up the request
  $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oid["tftphost"], "type" => 'a', "value" => "".$objdevice->tftpparam["tftpip"])
 		// set the filename being written
 		,array("oid" => $oid["file"], "type" => 's', "value" => $filetftp)
 		// 
 		,array("oid" => $oid["action"], "type" => 'i', "value" => $theaction)
		);
  $snmpok = $objdevice->set_list($to_do);
  $snmpok= $objdevice->retcode;

  if ($snmpok) {
    //set default status as "running"
    $result = $state["success"];
    $ret_val = "success";
/*
    $snmpok= true;
    $j = 0;
    // check for the results status
    while ($snmpok && (($result == $state["inProgress"]) && ($j <20))) {
		  // get the current status of the tftp server's action
		  $objdevice->get($oid["action"]);
		  $snmpok= $objdevice->retcode;
		  $ret_val = $objdevice->result;
		  $result = $ret_val;
                   sleep(3);
		  $j++; // not wait more than 60 seconds 
    }
    if ($result!=$state["success"]) {
       $ret_val= $error = "Error: SNMP Session failed during Transfert. ";
       foreach ($state as $ndx => $val) {
       	  if ($ndx == $result) {
       	    $ret_val.= $val;
       	    $error  .= $val;
       	  }
       }
       $snmpok = 0;
    }
*/
  } else {
    $ret_val= $error = "Error: SNMP Session failed during setting commands. ";
    $snmpok = 0;
  }

   $objdevice->result  = $ret_val;
   $objdevice->errormsg = $error;
   $objdevice->retcode = $snmpok;
}
