<?php
/*
 +-------------------------------------------------------------------------+
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************
    Author ......... Jean-Michel Pepin classes plugin for network devices (PEPJ in forum.cacti.net & http://cactiusers.org/forums/)
    Modified ....... .
    Program ........ class definition for Avaya network devices in PHP for Cacti or PHP software

    congratulation: For the TFTP part theses classes are based on the work of Pancho http://www.pancho.org
    & cacti http://www.cacti.net, 
    Thanks to all the developpers of cacti and pancho who make my work much easier for TFTP.
    TFTP Nortel Alteon & Accelar & Avaya & Baystack & Passport Jean-Francois Taltavull,
    
    reference: all mibs of Lucent, Att and Avaya (http://www.oidview.com/mibs)
*******************************************************************************/
/* define the OID of the vendor */
$toidvendor['lucent']    = '.1.3.6.1.4.1.1751'; //Nortel Baystack
$toidvendor['att']       = '.1.3.6.1.4.1.74';
$toidvendor['avaya']     = '.1.3.6.1.4.1.6889'; //  'norway'
$toidtovendor['.1.3.6.1.4.1.1751'] = 'avaya';
$toidtovendor['.1.3.6.1.4.1.74'] = 'avaya';
$toidtovendor['.1.3.6.1.4.1.6889'] = 'avaya';

class avayanetworkclass
{
   function vendorname($FunctionName)
   {
        return "avaya";       
   }
   function showclass()
   {
        return "this is a avaya class";       
   }
   function priv($obj,$FunctionName)
   {
   	$fct = "avaya".$FunctionName;
       	if (function_exists($fct)) $ret = $fct($obj);
       	else {
       	  $ret=0;
          $obj->result= array();
          $obj->errormsg = "Error: Function does not exist.";
          $obj->retcode = $ret;
       	}
        return $ret;
   }
   function tftp($obj)
   {
     global $networkclass_isdebug,$networkclass_islog;
     if ($obj->inittftp) {
      $typtransfert = avayaChecktypdevice($obj);
      if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG tftp typtransfert=".$typtransfert."\n");
      switch ($typtransfert) {
	case "att":
	  avayaTFTPtransfer($obj,"att");
	  break;
	case "avaya":
	  avayaTFTPtransfer($obj,"avaya");
	  break;
	case "lucent":
	  avayaTFTPtransfer($obj,"lucent");
	  break;
	default:
	   $obj->result= "unknow device";
	   $obj->retcode = 0;
	  break;
      }
     }
   }
   /* return if the device is a host */
   function DeviceIsHost($objdevice,$init=false) {
     global $networkclass_isdebug,$networkclass_islog;
     // NEVER for avaya class (only network devices)

     // the two following value could help you to find it
     // $obj->description();  // to be sure description has been ask at least one time
     // $description = $obj->result; or $description = $obj->description;
     // $oiddevice = $objdevice->oiddevice;
     //force debug $objdevice->setdebug(true,true);
     // if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG DeviceIsHost ->".print_r($valmib,true)."\n");
     if ($init) { $objdevice->ishost = false; }
     $result= $objdevice->ishost;
     return $result;
   }
}

/* return the type of the device (used only for the function in this class in case of a specific behaviour)
*/
function avayaChecktypdevice($obj) {
   $description  = $obj->description;
   $oiddevice  = $obj->oiddevice;
   $typdevice = "unknow";
   switch (true) {
	case (substr_count($oiddevice,"1.3.6.1.4.1.6889")>0):
	  $typdevice = "avaya";
	  break;
	case (substr_count($oiddevice,"1.3.6.1.4.1.74")>0):
	  $typdevice = "att";
	  break;
	case (substr_count($oiddevice,"1.3.6.1.4.1.1751")>0):
	  $typdevice = "lucent";
	  break;
	default:
	  $typdevice = "other";
	  break;
   }
   return $typdevice;
}

/* ************************************************************************
 Duplex : should return an array like
 $result[ifindex] = 0 for unknow, 1 for half duplex, 2 for full duplex, 3 auto;
*/
function avayaDuplex($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//$objdevice->setdebug(true,true);  //force manual debug
  $snmpok=0;
  $result = array();
  $msg = "Error: Duplex no response";
 $typ = avayaChecktypdevice($objdevice);
 if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Avaya $typ Duplex UNDER CONSTRUCTION "."\n");
 if ($typ=="lucent") {
 }
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Trunk : should return an array like in order to be independant for vendors
 $result[interfaceindex] = "0" no trunk "1","2",... for other state;
*/
function avayaTrunk($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);

 $snmpok=0;
 $result= array();
 $msg = "Error: no response";
 $typ = avayaChecktypdevice($objdevice);
 if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Avaya $typ Trunk UNDER CONSTRUCTION "."\n");
 if ($typ=="lucent") {
 }
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 VLAN : should return an array like in order to be independant for vendors
 $result["state"][vlanindex] = "0" for no VLAN or VLAN number;
 $result["VlanID"][vlanindex] = "0" for no VLAN or VLAN number;
 $result["index"][vlanindex] = ifindex;
 $result["nbport_by_vlan"][vlanindex] = nb ports in vlan
 $result["port_by_vlan"][vlanindex][] = array of ports in vlan
 $result["vlan_by_port"][vlanindex][] = array of ports in vlan
 $result["otherinfos"][] = array of other infos
 */
function avayaVLAN($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);

 $snmpok=0;
 $result= array();
 $msg = "Error: no response";
 $typ = avayaChecktypdevice($objdevice);
 if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Avaya $typ VLAN UNDER CONSTRUCTION "."\n");
 if ($typ=="lucent") {
 }
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Channel : should return an array with all type of channel like ... in order
  to be independant for vendors who have severals channel types
 $result["channelindex"][0..x]=channeltype (at least "LACP")
 $result["LACP"]["AdminKey"][ifIndex] = AdminKey of LaCP channel;  // "dot3adAggPortActorAdminKey"
 $result["LACP"]["OperKey"][ifIndex] = OperKey of LaCP channel;    // "dot3adAggPortActorOperKey"
 $result["LACP"]["PortSelectedAggID"][ifIndex] = Port Selected in which index of the LaCP channel // "dot3adAggPortSelectedAggID"
 $result["LACP"]["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel // "dot3adAggPortActorOperState"
 
 $result["other type of channel"]["PortActorOperState"][ifIndex] = ...;     "..."
 $result["other type of channel"]["pagpGroupIfIndex"][ifIndex] = Port Attached in which index of the ... channel or 0 for not attached
 ....
 */
function avayaChannel($objdevice) {
 networkclass_LACP($objdevice);
 $snmpok1 = $objdevice->retcode;
 $lacp = $objdevice->result;
 $result["channelindex"][0] = "LACP";
 $result["LACP"] = $lacp;
 $snmpok = $snmpok1;
 $objdevice->result =$result;
 if ($snmpok) $objdevice->errormsg = "";
 return $snmpok;
}

/* ************************************************************************
 LACP : should return an array like in order to be independant for vendors
 per default IEEE8023-LAG-MIB
 $result["AdminKey"][ifIndex] = AdminKey of LaCP channel;   "dot3adAggPortActorAdminKey"
 $result["OperKey"][ifIndex] = OperKey of LaCP channel;     "dot3adAggPortActorOperKey"
 $result["PortSelectedAggID"][ifIndex] = Port Selected in which index of the LaCP channel
 $result["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel
 */
function avayaLACP($objdevice) {
 networkclass_LACP($objdevice);
 return $objdevice->retcode;
}

/* ************************************************************************
 CPU : should return an array like
 $result["firstaveragename"][0] = value 1. average;
 $result["2averagename"][0] = value 2. average;
 $result["3averagename"][0] = value 3. average;
 .....
*/
function avayaCPU($objdevice) {
 $result["1Sec"] = 0;
 $result["5Sec"] = 0;
 $result["1min"] = 0;
 $ret=0;
 $msg = "Error: CPU status not enabled or not supported.";
 $typ = avayaChecktypdevice($objdevice);
 if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Avaya $typ CPU UNDER CONSTRUCTION "."\n");
 if ($typ=="lucent") {
 }
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $ret;
 return $ret;
}

/* ************************************************************************
 Temperature : should return an array of temperature (in degres Celsius) like
 $result["modulename"][0] = modulename; or ""
 $result["mean"][0] = 0;
 $result["min"][0] = value; or ""
 $result["max"][0] = value; or ""
 $result["state"][0] = value; or ""
PS: Fahrenheit to celsius (F - 32) / 1.8
*/
function avayaTemperature($objdevice) {
 $result=array();
  $ret=0;
  $msg = "Error: Temperature status table not enabled or not supported.";
  $typ = avayaChecktypdevice($objdevice);
  if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Avaya $typ Temperature UNDER CONSTRUCTION "."\n");
  if ($typ=="lucent") {
  }
  $objdevice->result= $result;
  $objdevice->errormsg = $msg;
  $objdevice->retcode = $ret;
  return $ret;
}
function avayaTFTPtransfert($objdevice,$typ) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $error ="";
 $ret_val="";
 $snmpok=0;
 $typ = avayaChecktypdevice($objdevice);
 if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Avaya $typ transfert UNDER CONSTRUCTION "."\n");
 if ($typ=="lucent") {
 }
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Avaya $typ transfert result: "."result=$ret_val".(($snmpok)?"":$error)."\n");
 $objdevice->result  = $ret_val;
 $objdevice->errormsg  = $error;
 $objdevice->retcode = $snmpok;
}

/* ************************************************************************
 TrapEvent : should return if the router has been changed in analysing the message of the syslog
 $result["changed"] = "running" "startup" or ""
 $result["host"] = host that has been changed;
 $result["date"] = 
           
 .....
!!!!!!!!!!!!! UNDER CONSTRUCTION !!!!!!!!!!!!!!!!!!!!!!!
*/
function avayaTrapEvent($objdevice,$syslogmsg="") {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok = 1; // default always OK but no trap
 $result = array("changed" => ""
                ,"host" => ""
                ,"date" => ""
                );
 $msg    = "Error: no trap configuration events";

 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

?>